# Event system
Testing some (potentially stupid 😅) ideas for a generic event system implmentation in C

[Example usage](src/main.c)

## Todos

- [x] Implement system initialisation
- [x] Implement system deinitialisation
- [ ] Implement registering new events
    - [x] Re-use a free slot if one exists
    - [x] Register a event new when not out of capacity and no free events exist
    - [ ] Re-allocate to add more events when out of capacity
- [x] Implement removing a previously registered event
- [ ] Implement adding new event listeners
    - [x] Re-use a free slot if one exists
    - [x] Register a new listeners when not out of capacity and no free listeners exist
    - [ ] Re-allocate to add more listeners when out of capacity
- [x] Implement removing an existing listener
- [x] Implement emitting an event
